<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class RecordAdminActions extends MB_Action
{
	public function execute()
	{
		global $CONF;

		// set all possible xml params here, $_POST is already cleaned
		$params = array("actionName");

		$adminGroupID = $_REQUEST["adminGroupID"];

		//Stop it if the array is built
		if($CONF["system"]["internal"]["recording".$CONF["user"]["sessionID"]]) {
			$recording = unserialize($CONF["system"]["internal"]["recording".$CONF["user"]["sessionID"]]);
			//Get rid of duplicates
			$actionNames = array_flip(array_flip($recording["actionNames"]));

			//Default actions
			$actionNames[] = "LoginResponse";
			$actionNames[] = "ShowLogin";
			$actionNames[] = "LogoutResponse";
			$actionNames[] = "ShowClientStats";

			$cmd = "<mbapi>
						<command>SetAdminGroups</command>
						<subCommand>update</subCommand>
						<params>
							<adminGroupID>".$recording["adminGroupID"]."</adminGroupID>
							<actionNames>";
				foreach($actionNames as $value) {
					if($value != "RecordAdminActions")
					$cmd .= "<actionName>$value</actionName>\n";
				}
				$cmd .= "</actionNames>\n";
			$cmd .= "</params>
					</mbapi>";

			$data = dispatchMBAPI($cmd, 1);

			$CONF["system"]["internal"]["recording".$CONF["user"]["sessionID"]] = "";
			storeConfigs("system", "internal");

			$m = new QueryMaster("delete", "config_params");
			$m->addAndClause("config_param_name", "=", "recording".$CONF["user"]["sessionID"], "s");
			$m->execute();
			redirect("admins.php",getActionID("ShowAdminGroupDetails"),array("adminGroupID" => $recording["adminGroupID"]));

		} else {
			$record["adminGroupID"] = $adminGroupID;
			$record["actionNames"] = "";
			$CONF["system"]["internal"]["recording".$CONF["user"]["sessionID"]] = serialize($record);
			storeConfigs("system", "internal");

		}
		if($this->addMBAPIErrors($data) === 0) {
			// show new admin record
			redirect("admins.php",getActionID("ShowAdminGroupDetails"),array("adminGroupID" => $recording["adminGroupID"]));
		}
	}
}