<?php
use Billing\Object\AffiliateProgram;

class Clients_AffiliateController extends Billing_Zend_Controller_Action_AdminController
{
    public function payoutAction()
   	{
   		$this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_AFFILIATE_PROGRAM_PAYOUT_TO_CREDIT'));
        $postData = $this->_request->getPost();
		$backUrl = $this->view->ActionUrl('clients', 'ShowAffiliateProgramsPartners', array('payout' => bgpc("payout", 0)));
        $payoutForm = new Billing_Zend_Form_Final_PayoutAffiliateCommissionsForm(array('context' => array(
           'cancelLink' =>  $backUrl,
           'affiliateProgramPartnerIds' => $this->getRequest()->getParam('id'),
           'postData' => $postData,
        )));
        if (0 == $payoutForm->getPayoutCount()) {
        	$this->_redirectWithMessage($backUrl, $this->_translator->translate("TRANS_AFFILIATE_PROGRAM_PAYOUT_EMPTY_MSG"), "error");
        }
        if ($this->_request->isPost() && $payoutForm->isValid($postData)) {
           try {
               $result = $payoutForm->processForm($postData);
               if ($result) {
                   $this->_redirectWithMessage($backUrl, $this->_translator->translate("TRANS_AFFILIATE_PROGRAM_PAYOUT_SUCCESS_MSG"), "info");
               }
           } catch (ProductException $e) {
               $this->_status->addError($e->getMessage());
           }
        }
        $this->view->form = $payoutForm;
   	}
}