<?php

use Billing\Manager\CompanyManager;

class Companies_IndexController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
        $this->_backUrl = ("ShowDashboard" == bgpc("redirectAction")) ? $this->view->ActionUrl('dashboard', 'ShowDashboard') : $this->view->adminActionUrl('configs', 'system', 'show');
	}

	public function indexAction()
	{
		$this->view->placeholder('pageTitle')->set($this->_translator->translate('TRANS_SETTINGS_COMPANY'));
		if ($reseller = getCurrentSession()->getReseller()) {
			$company = Factory()->Company($reseller->company_id);
		} else {
			$company = CompanyManager::getProviderCompany();
			$reseller = null;
		}
        $form = new Billing_Zend_Form_Final_CompanyForm($company, $reseller, array(
            'cancelUrl' => $this->_backUrl,
            "postData" => $postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL,
        ));
		if ($this->_request->isPost()) {
			try {
				if ($form->isValid($postData)) {
                    $form->process();
                    $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate('TRANS_SETTINGS_COMPANY_SUCCESS_EDIT'));
                }
			} catch (ProductException $e) {
				$this->_status->addError($e->getMessage());
			}
		}
		$this->view->form = $form;
    }

    private $_backUrl = NULL;
}