<?php

class Dashboard_HomeController extends Billing_Zend_Controller_Action_AdminController
{
	public function indexAction()
	{

		if ($reseller = getCurrentSession()->getReseller()) {
			$this->view->showQuickSetup = $reseller->hasAccessToSettings();
            if (!$this->view->showQuickSetup) {
                $this->_status->addWarning($this->_translator->translate('TRANS_RESELLER_FUNCTIONALITY_IS_LIMITED_BECAUSE_NO_ACTIVE_SUBSCRIPTION'));
            }
		} else {
			$this->view->showQuickSetup = true;
		}
		$this->view->isQuickSetupCollapsed = bgpc('dashboard-system-setup-hide', 0);
    }
    
    public function showBillingInfoAction()
    {
    	$this->_helper->layout->setLayout('ajax');
    	if ($reseller = getCurrentSession()->getReseller()) {
    		$billingInfo = Billing\Manager\CustomerManager::getBillingInfo($reseller->Client);
    		if (isset($billingInfo['credit_balance']) && !empty($billingInfo['credit_balance'])) {
    			$creditData = array();
    			foreach ($billingInfo['credit_balance'] as $currency => $amount) {
    				if ($amount != 0) {
    					$creditData[$currency] = $amount;
    				}
    			}
    			if ($creditData) {
    				$this->view->creditData = $creditData;
    			}
    		}
    		
    		$this->view->overuseData = Billing\Manager\CustomerManager::getTotalOveruse($reseller->Client);
    		
    		if (isset($billingInfo['invoices_due']) && !empty($billingInfo['invoices_due'])) {
    			$dueData = array();
    			foreach ($billingInfo['invoices_due'] as $currency => $amount) {
    				if ($amount != 0) {
    					$dueData[$currency] = $amount;
    				}
    			}
    			if ($dueData) {
    				$this->view->dueData = $dueData;
    			}
    		}
    	}
    }
    
}