<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class AddFraudSetResponse extends MB_Action
{
	public $params = array(
		"configGroupID",
		"fraudSetName",
		"fraudSetEmail",
	);

	public function execute()
	{
		parent::execute();

		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			$this->_completeAction();
		}

		$query = $this->getMBAPIQuery("SetFraudSets", "insert", array());
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$this->_completeAction();
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function _completeAction()
	{
		redirect("fraudsets.php", getActionID("ShowFraudSets"));
	}
}