<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class RemoveFraudSetResponse extends MB_Action
{
	public $params = array("fraudSetID");

	public function execute()
	{
		parent::execute();

		$fraudSetID = ((int) $_REQUEST["fraudSetID"]);
		if(!$fraudSetID) {
			$this->addError(TRANS_ACTIONERROR, "No fraudSetID ID given.");
		} else {
			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				$this->_completeAction();
			}
		    $query = $this->getMBAPIQuery("SetFraudSets", "delete", array());
		    $data = dispatchMBAPI($query, 1);

		    if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
        	    $this->_completeAction();
		    }
        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function _completeAction()
	{
		redirect("fraudsets.php", getActionID("ShowFraudSets"));
	}
}