<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class ShowFraudSetDetails extends MB_Action
{
	public $params = array("fraudSetID");

	public function execute()
	{
		parent::execute();

		$fraudSetID = ((int) $_REQUEST["fraudSetID"]);
		if(!$fraudSetID) {
			$this->addError(TRANS_ACTIONERROR, "No fraudSetID ID given.");
		} else {
            $args = array(
                'getOrderForms' => 1,
            	'vendorID' => getCurrentSession()->getVendorId(),
                'getCountryThresholdsData' => 1
            );
		    $query = $this->getMBAPIQuery("GetFraudSets", "", $args);
		    $data = dispatchMBAPI($query, 1);
		    $fraudSets =& $data["mbapi"][0]["results"][0];

		    if($this->addMBAPIErrors($data) === 0) {

			    $this->smartyVars["fraudSet"] = collapseArrayElements($fraudSets["fraudSets"][0]["fraudSet"]);

                // ------------------------------------------------
                // find all usedOrderForms
                // ------------------------------------------------
                $usedOrderForms = array();
                $c = count($fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"]);
                for($i=0;$i<$c;$i++){
                    $id = $fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"][$i]["orderFormID"][0];
                    $this->smartyVars["usedOrderForms"][$id] =
                        $fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"][$i]["orderFormName"][0];
                    $usedOrderForms[] = $id;
                }

                // ------------------------------------------------
                // find all availableOrderForms
                // ------------------------------------------------
                $availableOrderForms = array();
                if($usedOrderForms){
					$args = array(
						"notOrderFormIDs" => array("orderFormID"=>$usedOrderForms),
						"vendorID" => getCurrentSession()->getVendorId()
					);
                }
			    $query2 = $this->getMBAPIQuery("GetOrderForms", "", $args);
			    $data2 = dispatchMBAPI($query2, 1);
                $orderForms =& $data2["mbapi"][0]["results"][0];
                $c = count($orderForms["orderForms"][0]["orderForm"]);
                if (isset($orderForms["orderForms"][0]["orderForm"][0])){
					for($i=0;$i<$c;$i++){
						$id = $orderForms["orderForms"][0]["orderForm"][$i]["orderFormID"][0];
						if ((int) $id) {
							$this->smartyVars["availableOrderForms"][$id] =
								$orderForms["orderForms"][0]["orderForm"][$i]["orderFormName"][0];
							$availableOrderForms[] = $id;
						}
					}
                }

                // ------------------------------------------------
                // find all usedThresholds
                // ------------------------------------------------
                $usedThresholds = array();
                $c = count($fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"]);
                for($i=0;$i<$c;$i++){
                    $id = $fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"][$i]["thresholdID"][0];
                    $this->smartyVars["usedThresholds"][$id] =
                        $fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"][$i]["thresholdName"][0];
                    $usedThresholds[] = $id;
                }

                // ------------------------------------------------
                // find all availableThresholds
                // ------------------------------------------------
                $availableThresholds = array();
                if($usedThresholds){
					$args = array("notThresholdIDs"=>array("thresholdID"=>$usedThresholds));
                }
			    $query3 = $this->getMBAPIQuery("GetFraudCountryThresholds", "", $args);
			    $data3 = dispatchMBAPI($query3, 1);
                $thresholds =& $data3["mbapi"][0]["results"][0];
                if (isset($thresholds["countryThresholds"][0]["countryThreshold"][0])){
					$c = count($thresholds["countryThresholds"][0]["countryThreshold"]);
					for($i=0;$i<$c;$i++){
						$id = $thresholds["countryThresholds"][0]["countryThreshold"][$i]["thresholdID"][0];
						if ((int) $id) {
							$this->smartyVars["availableThresholds"][$id] =
								$thresholds["countryThresholds"][0]["countryThreshold"][$i]["thresholdName"][0];
							$availableThresholds[] = $id;
						}
					}
                }

			    // Set the templete for output
			    $this->mergeSystemNavData();
			    $this->addTemplate("fraudsets/ShowFraudSetDetails",$this->smartyVars, 1);
		    }
        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}