<?php
require_once ("lib-action/action.php");
use Billing\Object\Store;
use Billing\Object\Plan;
use Billing\Manager\PlanManager;

class AddHistoricalPackageMenu extends MB_Action
{
    public $params = array();

	public function execute()
    {
		$mode = getParam("mode");
		$clientID = getParam("clientID");
		$orderFormID = getParam("orderFormID");
		$productID = getParam("productID");
		$productVariantID = getParam("productVariantID");
		$cycleID = getParam("cycleID");
		$response = getParam("response", "s");

		$historical = $mode == "2" ? true : false;
		$this->smartyVars["historical"] = $historical;
		do {
			$try = false;
			// get selected information
			if($mode) {
				$this->smartyVars["mode"] = $mode;
			}
			if($clientID) {
				$this->smartyVars["clientID"] = $clientID;
			}
			if($orderFormID && !isset($this->smartyVars["orderForm"])) {
				$this->smartyVars["orderFormID"] = $orderFormID;
				$oft =& $this->getTableFromSource(new DataSource("orderForms", array("orderFormID" => $orderFormID)));
				$this->smartyVars["orderForm"] = $oft->getOne();
				$this->smartyVars["orderFormName"] = $oft->getOneName();
			}
			if($productID && !isset($this->smartyVars["product"])) {
				$this->smartyVars["productID"] = $productID;
				$pt =& $this->getTableFromSource(new DataSource("products", array("productID" => $productID)));
				$this->smartyVars["product"] = $pt->getOne();
				$this->smartyVars["productName"] = $pt->getOneName();
			}
			if($productVariantID && !isset($this->smartyVars["productVariant"])) {
				$this->smartyVars["productVariantID"] = $productVariantID;
				$pvt =& $this->getTableFromSource(new DataSource("productVariants", array("productVariantID" => $productVariantID)));
				$this->smartyVars["productVariant"] = $pvt->getOne();
				$this->smartyVars["productVariantPrimaryName"] = $pvt->getOneName();
			}
			if($cycleID && !isset($this->smartyVars["cycle"])) {
				$this->smartyVars["cycleID"] = $cycleID;
				$ct =& $this->getTableFromSource(new DataSource("cycles", array("cycleID" => $cycleID)));
				$this->smartyVars["cycle"] = $ct->getOne();
				$this->smartyVars["cycleDisplayName"] = $ct->getOneName();
			}

			// get selection information
			if($clientID && $orderFormID && $productID && $productVariantID && $cycleID) {
				redirect("packages.php", getActionID("AddHistoricalPackage"), array(
					"mode" => $mode,
					"clientID" => $clientID,
					"orderFormID" => $orderFormID,
					"productID" => $productID,
					"productVariantID" => $productVariantID,
					"cycleID" => $cycleID,
				));
			} else if($clientID && $orderFormID && $productID && $productVariantID) {
				// get cycles associated with the product of the selected product variant
				$productVariant = Factory()->ProductVariant($productVariantID);
                $this->smartyVars["cycleOptions"] = DataObject::getMapOf($productVariant->getConfiguredCycles(), "cycle_id", "cycle_display_name");
				$this->addTemplate("packages/AddHistoricalPackageMenu");
                
			} else if($clientID && $orderFormID && $productID) {
				// get product variants of the products associated with the order form
                $plan = Factory()->Plan($productID);
                $productVariants = $plan->ProductVariantList(array("product_variant_active" => 1));
                $productVariantOptions = array();
                foreach($productVariants as $variant) {
                    if (Plan::TYPE_DOMAIN == $plan->product_type) {
                        if (is_null($variant->tld_id)) {
                            continue;
                        }
                        $tld = Factory()->TLD($variant->tld_id);
                        if (is_null($tld->registrar_id) || 1 != $tld->tld_active) {
                            continue;
                        }
                        require_once("object_managers/BillingRegistrarManager.php");
                        $registrar = Factory()->BillingRegistrar(array($tld->registrar_id, Factory()->Store($orderFormID)->vendor_id));
                        if (1 != $registrar->module_enabled || ($registrar->isPBAModule() && !BillingRegistrarManager::isHSPCAvailable())) {
                            continue;
                        }
                    }
                    $productVariantOptions[$variant->product_variant_id] = $variant->product_variant_display_name;
                }
 				$this->smartyVars["productVariantOptions"] = $productVariantOptions;

                if(count($this->smartyVars["productVariantOptions"]) == 1) {
					$try = true;
					$productVariantID = current(array_keys($this->smartyVars["productVariantOptions"]));
					unset($this->smartyVars["productVariantOptions"]);
					continue;
				}
				foreach($this->smartyVars["productVariantOptions"] as $productVariantID => $productVariantDisplayName) {
					if("" != $productVariantDisplayName) {
						continue;
					}

					$this->smartyVars["productVariantOptions"][$productVariantID] = Factory()->TLD(Factory()->ProductVariant($productVariantID)->tld_id)->tld_name;
				}
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else if($clientID && $orderFormID) {
				// get product variants of the products associated with the order form
				// Use generic data source for optimized option fetching
				$this->smartyVars["productOptions"] = array();
                foreach ( Factory()->Store($orderFormID)->ProductList() as $plan ) {
                    if (1 != $plan->product_active) {
                        continue;
                    }
					if (PlanManager::isPlanValidForStores($plan, array($orderFormID))) {
						$this->smartyVars["productOptions"][$plan->id] = billing_safetyhtml($plan->product_name);
					}
				}
				if(count($this->smartyVars["productOptions"]) == 1) {
					$try = true;
					$productID = current(array_keys($this->smartyVars["productOptions"]));
					unset($this->smartyVars["productOptions"]);
					continue;
				}
				if (0 == count($this->smartyVars["productOptions"]))
				{
					$this->smartyVars["noObjectsMessage"] = blmsg("TRANS_NO_ACTIVE_PLANS_ASSIGNED_TO_SELECTED_ONLINE_STORE");
					unset($this->smartyVars["productOptions"]);
					$orderFormID = NULL;
					$try = true;
					continue;
				}
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else if($clientID) {
				// get order forms
				if($productID) {
					$oD = new DataSource(
						"productsGeneric",
						array(
							"productID" => $productID,
							"orderForms" => array(
								"optionColumns" => 1,
							)
						)
					);
					$oE = $oD->getEssential();
					$oT = new Table($oE[0]["orderForms"], "orderFormID", "orderFormName");
					$this->smartyVars["orderFormOptions"] = $oT->getOptions();
				} else {
					// filter list of stores according to vendor id and type of client (customer or reseller)
					$client = Factory()->Customer($clientID);
					$type = $client->isReseller() ? Store::TYPE_RESELLER : Store::TYPE_CUSTOMER;
					$stores = array();
					foreach (Factory()->OrderFormList(array('vendor_id' => getCurrentSession()->getVendorId(), 'order_form_type' => $type)) as $store) {
						$stores[$store->id] = $store->order_form_name;
					}
					$this->smartyVars["orderFormOptions"] = $stores;
				}
				if(count($this->smartyVars["orderFormOptions"]) == 1) {
					$try = true;
					$orderFormID = current(array_keys($this->smartyVars["orderFormOptions"]));
					unset($this->smartyVars["orderFormOptions"]);
					continue;
				}
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else {
				$this->addError(TRANS_ACTIONERROR, "Needs at least a client ID to get started.");
				break;
			}

		} while($try);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
