<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-billing/include/config/internal/cycles.php");

class AddPackageAddon extends MB_Action
{
	public $params = array("packageID");

	public function execute()
	{
		parent::execute();

		$this->smartyVars["types"] = getTypes("products");

		$this->smartyVars["rawPackageAddons"] = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackageAddons",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
					"packageAddonActive" => 1,
				),
			),
		)));
		dbg($this->smartyVars["rawPackageAddons"]);

		$this->smartyVars["packageAddons"] = array();
		foreach ((array)$this->smartyVars["rawPackageAddons"] as $k=>$pkga){
			$this->smartyVars["packageAddons"][$pkga["packageAddonProductID"]] =& $this->smartyVars["rawPackageAddons"][$k];
		}

		dbg("package addons keyed by product id:");
		dbg($this->smartyVars["packageAddons"]);

		$this->smartyVars["packageInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
				),
			),
		)));

		dbg("got package info");

		$productsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("
			<mbapi>
				<command>GetProducts</command>
				<params>
					<parentProductID>".$this->smartyVars["packageInfo"]["productID"]."</parentProductID>
					<productActive>1</productActive>
					<getProductAttributeData>1</getProductAttributeData>
					<getCouponData>1</getCouponData>
					<getAllOrderFormItemData>1</getAllOrderFormItemData>
					<getOrderFormItemData>1</getOrderFormItemData>
					<getOrderFormData>1</getOrderFormData>
					<getProductVariantData>1</getProductVariantData>
					<getProductVariantPriceData>1</getProductVariantPriceData>
					<getTLDData>1</getTLDData>
					<getCycleData>1</getCycleData>
				</params>
			</mbapi>", 1)));

		$addonGroupIDs = array();
		$this->smartyVars["productAddons"] = array();
		foreach ((array)$productsInfo as $k=>$addon){
			$this->smartyVars["productAddons"][$addon["productID"]] =& $productsInfo[$k];
			$addonGroupIDs[] = $addon["productAddonGroupID"];
		}

		$this->smartyVars["rawProductAddonGroups"] = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"productAddonGroupID" => $addonGroupIDs,
				),
			),
		)));

		$this->smartyVars["productAddonGroups"] = array();
		foreach ((array)$this->smartyVars["rawProductAddonGroups"] as $k=>$addonGroup){
			$this->smartyVars["productAddonGroups"][$addonGroup["productAddonGroupID"]] = $this->smartyVars["rawProductAddonGroups"][$k];
		}


		foreach ($this->smartyVars["packageAddons"] as $productID=>$packageAddon){
			$groupID = $this->smartyVars["productAddons"][$productID]["productAddonGroupID"];
			dbg("package addon: ".$packageAddon["packageAddonDisplayName"]." has product id of: ".$productID);
			dbg("matching product info:");
			dbg($this->smartyVars["productAddons"][$productID]);
			if ($this->smartyVars["productAddonGroups"][$groupID]["productAddonGroupInputType"]!=getAPITypeID("addoninputs", "checkbox")){
				unset($this->smartyVars["productAddonGroups"][$groupID]);
			}
		}

		foreach ((array)$productsInfo as $k=>$addon){
			if ((int)$this->smartyVars["packageAddons"][$addon["productID"]]["packageID"]){
				dbg("unset product id: ".$addon["productID"]);
				unset($productsInfo[$k]);
				unset($this->smartyVars["productAddons"][$addon["productID"]]);
			}
		}

		dbg("groups we dont have an addon in:");
		dbg($this->smartyVars["productAddonGroups"]);


		foreach ((array)$productsInfo as $k=>$v){
			$prices = array();
		 	if (isset($productsInfo[$k]["productVariantPrices"])){
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
				 	//dbg("compared: ");
				 	//dbg("currency id: ".$price["currencyID"]);
				 	//dbg("cycle id: ".$price["cycleID"]);
					//dbg("match to cycle: ".$this->smartyVars["packageInfo"]["cycleID"]);
					//dbg("match to currency: ".$this->smartyVars["packageInfo"]["currencyID"]);
					//dbg("");
					//dbg("");
					//dbg("");
					if ($price["currencyID"]==$this->smartyVars["packageInfo"]["currencyID"] && $price["cycleID"]==$this->smartyVars["packageInfo"]["cycleID"]){
						$prices[$price["productVariantPriceType"]] = $price;
					}
				}
			} else {
				dbg("variant price not set");
			}
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
			} else {
			 	unset($productsInfo[$k]);
			}
		}

		$keyedAddons = array();
		foreach ($productsInfo as $k=>$row){
		 	$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
		}

		$this->smartyVars["addonGroups"] =& $this->smartyVars["productAddonGroups"];
		foreach ($keyedAddons as $groupID=>$data){
			if (!$this->smartyVars["addonGroups"][$groupID]){
				unset($keyedAddons[$groupID]);
			}
		}

		$this->smartyVars["products"] = $keyedAddons;

		$subscription = Factory()->Subscription(bgpc("packageID"));
		$this->smartyVars["packageInfo"]["canTransfer"] = $subscription->canTransfer();
		$this->smartyVars["packageInfo"]["canUpgrade"] = $subscription->canUpgrade();
		$this->smartyVars["packageInfo"]["canDowngrade"] = $subscription->canDowngrade();

		$this->addTemplate("packages/AddPackageAddon");
	}
}
