<?php
require_once ("lib-action/action.php");

use Billing\Manager\SubscriptionManager;

class ChangePackageClient extends MB_Action
{
	public function execute()
	{
		parent::execute();

        try {

            if (is_null($packageID = bgpc('packageID')) || !($packageInfo = oneByID("packages", $packageID))) {
                billing_put_error("Invalid package ID given.");
                redirect("packages.php", getActionID("ShowPackages"), array());
            }
            $clientID = bgpc('clientID');
            if (!getCurrentSession()->checkVendor(Factory()->Client($clientID))) {
                throw new ProductException(ProductException::E_FORBIDDEN_OPERATION, "Access denied: Client with ID '{$clientID}'");
            }
            $clientInfo = oneByID("clients", $clientID, array("mergePrimaryContact" => 1,));
            $this->smartyVars["toClient"] = $clientInfo;
            $this->smartyVars["package"] = $packageInfo;
            $this->smartyVars["fromClient"] = oneByID("clients", $packageInfo["clientID"], array(
                "mergePrimaryContact" => 1,
            ));
            $this->smartyVars["selectableBillingAccounts"] = array('') + optionsFor("clientBillingAccounts", array("clientID"=>$clientID));
            $this->smartyVars["packageTypes"] = getTypes("products");
			$subscription = Factory()->Subscription($packageID);
			$this->smartyVars["package"]["canTransfer"] = $subscription->canTransfer();
			$this->smartyVars["package"]["canUpgrade"] = $subscription->canUpgrade();
			$this->smartyVars["package"]["canDowngrade"] = $subscription->canDowngrade();

			SubscriptionManager::checkTransferSubscription($subscription, $subscription->client_id, $clientID);

            $this->addTemplate("packages/ChangePackageClient", $this->smartyVars);

        } catch(ProductException $e) {
            billing_put_error($e->getMessage());
            redirect("packages.php", getActionID("ShowPackageDetails"), array("packageID" => $packageID));
        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
