<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/toolkit.php");

class UpdatePackageBillingSharesResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if ($packageID = (int)$_REQUEST["packageID"]){
			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				redirect("packages.php", getActionID("ShowPackageDetails"), array("packageID" => $packageID));
			}

			if ((int)$_REQUEST["billingAccountID"]){
				$shares = grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetBillingAccountShares",
						"params" => array(
							"packageID" => $packageID,
						),
					),
				));
				$done = false;
				foreach ((array)$shares as $s){
					if ($s["billingAccountID"]==$_REQUEST["billingAccountID"]){
						updateForKey(":clientBillingAccountShares", $s["billingAccountShareID"], array(
							"billingAccountShareValue" => 1,
						));
						$done = true;
					} else {
						updateForKey(":clientBillingAccountShares", $s["billingAccountShareID"], array(
							"billingAccountShareValue" => 0,
						));
					}
				}

				if (!$done){
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "insert",
							"params" => array(
								"billingAccountID" => $_REQUEST["billingAccountID"],
								"packageID" => $packageID,
								"billingAccountFallbackGroup" => 1,
								"billingAccountShareGroup" => 0,
								"billingAccountShareValue" => 1,
							),
						),
					)));
				}

			} else {

				$shares = grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetBillingAccountShares",
						"params" => array(
							"packageID" => $packageID,
						),
					),
				));

				$existingShares = array();
				foreach ($shares as $share){
					$existingShares[$share["billingAccountID"]] = $share;
				}

				$newShares = array();
				$updateShares = array();
				foreach ($_REQUEST as $k=>$v){
					$test = @substr($k, 0, 11);
					$id = str_replace("shareValue_", "", $k);
					if ($test=="shareValue_"){
						if ($existingShares[$id]){
							$updateShares[$existingShares[$id]["billingAccountShareID"]] = $v;
							unset($existingShares[$id]);
						} else {
							$newShares[$id] = $v;
						}
					}
				}

				foreach ($newShares as $billingAccountID=>$shareValue){
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "insert",
							"params" => array(
								"billingAccountID" => $billingAccountID,
								"packageID" => $packageID,
								"billingAccountFallbackGroup" => 1,
								"billingAccountShareGroup" => 0,
								"billingAccountShareValue" => $shareValue,
							),
						),
					)));
				}

				foreach ($updateShares as $shareID=>$shareValue){
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "update",
							"params" => array(
								"billingAccountShareID" => $shareID,
								"billingAccountShareValue" => $shareValue,
							),
						),
					)));
				}

				foreach ($existingShares as $billingAccountID=>$share){
					$shareID = $share["billingAccountShareID"];
					$shareValue = 0;
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "update",
							"params" => array(
								"billingAccountShareID" => $shareID,
								"billingAccountShareValue" => $shareValue,
							),
						),
					)));
				}
			}

			redirect("packages.php", getActionID("ShowPackageDetails"), array("packageID" => $packageID));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
