<?php

require_once("lib-action/action.php");

class UpgradeDowngradeAction extends MB_Action
{
	protected function canUpgradeDowngrade(array $packageInfo)
	{
		if ("" == $packageInfo["upgradeLockingDate"]) {
			return true;
		}
		$lockingTime = strtotime($packageInfo["upgradeLockingDate"]);
		$lockingTime = $lockingTime - ($lockingTime%(24*60*60)) + (24*60*60);
		$priorFeeData = oneOf(":packageFeeRels", array(
			"packageID" => $packageInfo["packageID"],
		));
		if ($priorFeeData) {
			$packageIDs = array($packageInfo["packageID"], $priorFeeData["packageFeeID"]);
		} else {
			$packageIDs = $packageInfo["packageID"];
		}
		$lineItems = arrayFor("lineItems", array(
			"packageID" => $packageIDs,
			"sortColumn" => "lineItemDateCurrentRenewal",
			"sortDir" => "ASC",
			"lineItemDateNextRenewalGreaterThan" => $lockingTime - 1,
		));
		return (0 < count($lineItems));
	}
}
