<?php
require_once ("lib-action/action.php");

class RunPaymentQueue extends MB_Action
{
	public function execute()
    {
		global $CONF;
		parent::execute();
		loadConfigs("payment");

        $this->smartyVars["hideEventStatusBar"] = 1;
		$this->smartyVars["transactionAction"] = Settings()->paymentQueue_transactionAction;
        $this->smartyVars["queueRunTime"] = time();
        $timeData = explode(";", date("i;G;j;n;Y"));


        if ( $CONF["system"]["internal"]["systemQueueCommand"] != "ProcessPaymentQueue" || !$CONF["system"]["internal"]["systemQueueRunning"]){

            $this->addTemplate("paymentqueue/RunPaymentQueue");

        } else {

            $this->smartyVars["showStatus"] = "yes";
            // get anything from the queue
            $getQueueXML = "
    <mbapi>
        <command>GetSystemQueue</command>
        <params>
            <systemQueueID>".$CONF["system"]["internal"]["systemQueueID"]."</systemQueueID>
        </params>
    </mbapi>
            ";
            $queueItem = dispatchMBAPI($getQueueXML, 1);

            $this->smartyVars["queueRunTime"] = $queueItem["mbapi"][0]["results"][0]["systemQueue"][0]["systemQueueEvent"][0]["systemQueueDateToRun"][0];

            $this->addTemplate("paymentqueue/RunPaymentQueueResponse");

        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} 