<?php

require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-billing/include/config/internal/emailactions.php");

/**
 * This Action object takes information provided by the AddSkeletonProduct action, applies that information to
 * records in the database, and redirects to the AddSkeletonProduct action for the given package.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddSkeletonProduct extends MB_Action {
	/**
	 * The constructor for an AddSkeletonProduct action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddSkeletonProduct() {
		parent::MB_Action();
		$this->stringRep = "AddSkeletonProduct";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the AddSkeletonProduct action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		do {
			$skeleton = array(
				"productName" => TRANS_SKELETON_PRODUCT,
				"productType" => getTypeID("products", TRANS_UNDEFINED_PRODUCT),
				"productComments" => "",
				"productStopNumCycles" => 0,
				"productActive" => 0,
				"productProratable" => 1,
				"productDomainRequired" => getAPIStatusID("productdependencyrules", "can"),
				"productAddonRequired" => getAPIStatusID("productdependencyrules", "can"),
				"productDateCreated" => mktime(),
			);

			/*
			$emailActionGroups = array();
			
			$q = new MBQuery("GetEmailActionGroups", "", array("emailActionID" => getTypeID("emailAction", TRANS_SIGNUP)));
			if(!$this->addErrorsFromResult($r =& $q->getResult())) break;
			$t =& $r->getTableFrom(
				array("mbapi", "results", "emailActionGroups", "emailActionGroup"),
				"emailActionGroupID", "emailActionGroupName"
			);
			$IDs = $t->getKeys();
			if(isset($IDs[0])) $emailActionGroups[] =$IDs[0];

			$q = new MBQuery("GetEmailActionGroups", "", array("emailActionID" => getTypeID("emailAction", TRANS_WELCOME)));
			if(!$this->addErrorsFromResult($r =& $q->getResult())) break;
			$t =& $r->getTableFrom(
				array("mbapi", "results", "emailActionGroups", "emailActionGroup"),
				"emailActionGroupID", "emailActionGroupName"
			);
			$IDs = $t->getKeys();
			if(isset($IDs[0])) $emailActionGroups[] = $IDs[0];
			
			if($emailActionGroups) $skeleton['emailActionGroupIDs'] = array('emailActionGroupID' => $emailActionGroups);
			*/
			
			$q = new MBQuery("SetProducts", "insert", $skeleton);
		
			//echo '<pre>' . htmlentities($q->getXMLQuery()) . '</pre>'; exit;
		
			if(!$this->addErrorsFromResult($r =& $q->getResult())) break;
			
			$productID = $r->getLastInsertID();
			
			$this->syncProductVariants($productID);
			
			if (!$this->goBack()){
				redirect("products.php?action=".getActionID("ShowProductDetails")."&advanced=1&productID=".$r->getLastInsertID());
			}
		} while (false);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddSkeletonProduct
?>
