<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-billing/include/config/internal/cycles.php");

use Billing\Manager\SubscriptionManager;
use Billing\Object\Subscription;

class CancelPackageResponse extends MB_Action
{
	public function execute()
	{
		global $CONF;
		$this->smartyVars["package"] = grabFirstResultFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"packageID" => (int)$_REQUEST["packageID"],
					)
				)
			)
		);

		dbg("got package, going in");
		if (!(int)$this->smartyVars["package"]["packageID"] || $this->smartyVars["package"]["packageCancellationType"]==getAPITypeID("cancellation", "admin_delete") || $this->smartyVars["package"]["packageCancellationType"]==getAPITypeID("cancellation", "admin_suspend")){
			$this->addError(TRANS_ACTIONERROR, "Invalid Package ID Provided.");
			$this->hasExecutedSuccessfully = 0;
		} else {
			dbg("got past error checking");
			if ($this->smartyVars["package"]["packagePendingCancellation"]==0 && $_REQUEST["desiredAction"]=="cancel"){
				dbg("got into cancellation area");
				$query = new MBQuery("SetPackages", "update", array("packageID"=>$this->smartyVars["package"]["packageID"], "packagePendingCancellation"=>1));
				dbg(dispatchMBAPI($query->getXMLQuery()));
			} elseif ($this->smartyVars["package"]["packagePendingCancellation"]==1 && $_REQUEST["desiredAction"]=="uncancel"){
				$query = new MBQuery("SetPackages", "update", array("packageID"=>$this->smartyVars["package"]["packageID"], "packagePendingCancellation"=>0));
				dispatchMBAPI($query->getXMLQuery());
			} else if (Subscription::PENDING_CANCELLATION_TYPE_UPGRADE == $this->smartyVars["package"]["packagePendingCancellation"] && $_REQUEST["desiredAction"]=="cancel") {
				$subscription = Factory()->Subscription($this->smartyVars["package"]["packageID"]);
				try {
					SubscriptionManager::cancelUpgrade($subscription);
					billing_put_info(blmsg('TRANS_SUBSCRIPTION_OPERATION_CANCEL_UPGRADE_DOWNGRADE_SUCCESS_MSG'));
				} catch (ProductException $e) {
					billing_put_error($e->getMessage());
				}
			}
			redirect("packages.php?action=".getActionID("ShowPackages"));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
