{*
 * --------------------------------------------------------------
 * This template displays the client dashboard.
 *
 * Smarty Variables:
 *  $invoices (array of invoice data)
 *  $packages (array of package data)
 *  $overuses (array of overuse data)
 *  $helpdeskTicketsOpen (array of open tickets)
 *  $helpdeskTicketsOpenSubject (array of open ticket's subjects)
 *  $helpdeskEnabled (1 or 0 to show the helpdesk section)
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Michael Fountain
 *}

{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="overview"}

{if $showPPCOffer}
    {include file="$tplDirectory/widgets/google/showAcceptedOffer.tpl"}
    <br />
{/if}

{$messages}

{if null != $overuses}
<div class="box07" style="background-color:#EEEDE9">
	<div class="st01"><h1 style="margin-bottom: 0px;">{"TRANS_TOTAL_OVERUSE"|lmsg}</h1></div>
    <table border="0" cellspacing="0" cellpadding="0" class="tabTight"><tr><td>
    <table border="0" cellspacing="0" cellpadding="0" class="list">
            {foreach key=currency item=overuse from=$overuses}
                <tr class="{cycle values="alt1,alt2"}">
                    <td style="text-align: left;">{$overuse|getAmount:$currency}</td>
                </tr>
            {/foreach}
            <tr >
                <td style="text-align: left;">
                    <a href="{getHREF page="overuses.php" actionName="ShowOveruseDetails}">
                        {"TRANS_SEE_DETAILS"|lmsg}
                    </a>
                </td>
            </tr>
    </table>
</td></tr></table>
    </div>{* box07x *}
    <br /><br /><br />
{/if}
<div class="box07" style="background-color:#EEEDE9">
	<div class="st01"><h1 style="margin-bottom: 0px;">{"TRANS_INVOICES_DUE"|lmsg}</h1></div>
<table border="0" cellspacing="0" cellpadding="0" class="tabTight"><tr><td>
<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
    <tr class="headerRow">
	    <td style="text-align: center;">
            {"TRANS_INVOICE_NUMBER"|lmsg}
        </td>
        <td style="text-align: center;">
            {"TRANS_AMOUNT"|lmsg}
        </td>
        <td style="text-align: center;">
            {"TRANS_AMOUNT_PAID"|lmsg}
        </td>
	    <td style="text-align: center;">
		    {"TRANS_DATE_GENERATED"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_DATE_DUE"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_STATUS"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_ACTION"|lmsg}
	    </td>
    </tr>
    {section name=i loop=$invoices}
    	{if $invoices[i].invoiceAmount!=$invoices[i].invoiceAmountPaid}
    	{assign var="invoiceEchod" value=1}
        <tr class="{cycle values="alt1,alt2"}">
            <td style="text-align: center;">
				<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoices[i].invoiceID`"}">
					{$invoices[i].invoiceNumber}
				</a>
            </td>
            <td style="text-align: right;">
                {$invoices[i].invoiceAmount|getAmount:$invoices[i].currencyID}
            </td>
            <td style="text-align: right;">
                {$invoices[i].invoiceAmountPaid|getAmount:$invoices[i].currencyID}
            </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceDateEntered|getDate}
	        </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceDateDue|getDate}
	        </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceStatus|getStatusName:"invoice"}
	        </td>
	        <td style="text-align: center;">
			 	<div class="rm"><a class="sb-pay-now" href="{getHREF page="invoices.php" actionName="PayInvoices"}&amp;invoiceID={$invoices[i].invoiceID}"> {"TRANS_PAY_NOW"|lmsg}</a></div>
	        </td>
        </tr>
        {/if}
    {/section}
    {if $invoiceEchod!=1}
        <tr class="alt1">
            <td style="text-align: left;" colspan="7"><i>{"TRANS_NONE"|lmsg}</i></td>
        </tr>
    {else}
        <tr class="listButtons alt1">
	        <td colspan="7"><div>
			 	<div class="rm"><a class="sb-pay-all" href="{getHREF page="invoices.php" actionName="PayInvoices"}">{"TRANS_PAY_ALL"|lmsg}</a><div>
	        </div></td>
        </tr>
    {/if}
	</table>
</td></tr></table>
</div>{* box07x *}
<br />
<div class="box07" style="background-color:#EEEDE9">
	<div class="st01"><h1 style="margin-bottom: 0px;">{"TRANS_ACTIVE_BILLABLE_PACKAGES"|lmsg}</h1></div>
<table border="0" cellspacing="0" cellpadding="0" class="tabTight"><tr><td>
	<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
    <tr class="headerRow">
	    <td style="text-align: center;">
		    {"TRANS_ID"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_PACKAGE"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_PRICE"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_BILLING_CYCLE"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_NEXT_RENEWAL"|lmsg}
	    </td>
	    <td  style="text-align: center;">
		    {"TRANS_STATUS"|lmsg}
	    </td>
    </tr>
    {section name=i loop=$packages}
        <tr class="{cycle values="alt1,alt2"}">
	        <td style="text-align: left;">
		        {$packages[i].packageID}
	        </td>
	        <td style="text-align: left;">
	        <a href="{getHREF page="packages.php" actionName="ShowPackageDetails"}&amp;packageID={$packages[i].packageID}">
		        {$packages[i].packageName|safetyhtml|stripslashes}
		    </a>
		        {if $packages[i].domains.0.domainID>0}
		        	{foreach item="domain" key="dk" from=$packages[i].domains}
		        		<br />
		        		<!-- <a href="{getHREF page="domains.php" actionName="ShowDomainDetails" args="domainID=`$domain.domainID`"}"> --><strong>{$domain.domainSLD}.{$domain.domainTLD}</strong><!-- </a> -->
		        	{/foreach}
		        {/if}
	        </td>
	        <td style="text-align: right;">
		        {$packages[i].packagePrice|getAmount:$packages[i].currencyID}
	        </td>
	        <td style="text-align: center;">
		        {$packages[i].cycleID|getArrayValueByID:$cycles}
	        </td>
	        <td style="text-align: center;">
		        {$packages[i].packageDateNextRenewal|getDate}
	        </td>
	        <td  style="text-align: center;">
		        {$packages[i].packageStatus|getStatusName:"package"}
	        </td>
        </tr>
    {sectionelse}
        <tr class="alt1">
            <td colspan="7"><i>{"TRANS_NONE"|lmsg}</i></td>
        </tr>
    {/section}
	</table>
</td></tr></table>
</div>{* box07x *}
<br />



{include file="$tplDirectory/footer.tpl"}
