<?php use_helper('BillingFormat') ?>
<div id="main" class="">

	<div class="p-store-order">

		<?php include_partial('navigationBar', array('router' => $router)); ?>

		<div class="p-box p-box-features">
			<div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>

			<div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
				<div class="p-box-infobar">
					<ul class="p-box-infobar-list">
						<li class="p-box-infobar-item i-purchased-products"><?php echo __('TRANS_SELECTED_PLAN'); ?>: <b><?php echo $plan->productName; ?></b></li>
                        <?php foreach ($domains as $name => $type): ?>
						<li class="p-box-infobar-item i-domain"><?php echo __($type == BillingDomainPlan::PURCHASE_TYPE_REGISTER ? 'TRANS_DOMAIN_TO_BE_REGISTERED' : ($type == BillingDomainPlan::PURCHASE_TYPE_TRANSFER ? 'TRANS_DOMAIN_TO_BE_TRANSFERED' : 'TRANS_USE_EXISTING_DOMAIN')); ?>: <b><?php echo $name; ?></b></li>
						<?php endforeach; ?>
					</ul>
				</div>

				<form id="purchaseServices" action="<?php echo url_for('@select-services'); ?>" method="post">

					<div class="p-box-title p-box-title-1">
						<div class="p-box-title-area">
							<h1><span><?php echo __('TRANS_STORE_ADDITIONAL_SERVICES'); ?></span></h1>
						</div>
					</div>

					<div class="p-box-content">

						<?php if (isset($errorMessage)): ?>
						<?php include_partial('errorMessage', array('message' => $errorMessage)); ?>
						<?php endif; ?>

						<div class="b-description"><p><?php echo __('TRANS_STORE_ADDITIONAL_SERVICES_DESC'); ?></p></div>

						<div class="b-features">
							<h4><?php echo __('TRANS_STORE_SERVICES'); ?></h4>
							<div class="b-features-area">
								<table class="t-features">
									<tbody>
										<?php foreach ($services as $service): ?>
											<?php if (is_null($purchaseId) || !isset($selectedServices[$purchaseId][$service->getId()])): ?>
											<tr>
												<td class="">
													<label for="service-<?php echo $purchaseId; ?>-<?php echo $service->getId(); ?>">
														<input type="checkbox" class="radio" name="service_<?php echo $purchaseId; ?>_<?php echo $service->getId(); ?>" value="<?php echo $service->getId(); ?>" id="service-<?php echo $purchaseId; ?>-<?php echo $service->getId(); ?>"/> - <?php echo $service->productName; ?>
													</label>
													<?php if (!empty($service->productComments)) : ?>
														<span class="addon-descripion">
															<?php echo $service->productComments; ?>
														</span>
													<?php endif; ?>
												</td>
												<td class="t-feature-price">
													<input type="hidden" name="price_<?php echo $service->getId(); ?>" value="<?php echo $service->getPrice()->getId(); ?>"/>
													<input type="hidden" name="cycle_<?php echo $service->getId(); ?>" value="<?php echo $service->getPrice()->getCycleId(); ?>"/>
													<b><?php echo formatPrice($service->getPrice()->getCycleFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($service->getCycle($service->getPrice()->cycleID)->cycleDisplayName); ?>
													<?php include_partial('catalog/priceAdditionalData', array('price' => $service->getPrice(), 'currencyId' => $currencyId)); ?>
												</td>
											</tr>
										    <?php endif; ?>
										<?php endforeach; ?>
									</tbody>
								</table>
							</div>
						</div>
					</div>

				</form>

			</div></div></div>
			<div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
		</div>

		<div class="p-store-actions">
			<div class="p-store-actions-area">
                <?php if(!is_null($purchaseId)) :?>
				    <?php include_partial('backAction', array('router' => $router)); ?>
                <?php endif; ?>
				<a class="btn btn-action" href="#" onclick="$('#purchaseServices').submit(); return false;"><span><i><?php echo __('TRANS_NEXT'); ?></i></span></a>
			</div>
		</div>

		<?php if (isset($taxZone)): ?>
		<div class="b-note-tax"><?php echo __('TRANS_INCLUDE_TAX_TO_PRODUCT_PRICES', array('%NAME%' => $taxZone->taxZoneDescription, '%AMOUNT%' => formatTax($taxZone->getRawValue(), $currencyId))); ?></div>
		<?php endif; ?>

	</div> <!--/p-store-order-->

</div> <!--/#main-->