<?php

class BillingServiceService extends BillingService
{
	protected static $instance = null;

	public function getById($serviceId, $planId, $storeId, $cycleId, $couponId = false, $anonymously = false)
	{
		$clientId = (!$anonymously && ($customer = sfContext::getInstance()->getUser()->getAttribute('customer'))) ? $customer->getId() : null;
		$customerData = sfContext::getInstance()->getUser()->getAttribute('customerData', array());
		$service = null;
		$response = $this->executeGetServices($storeId, $planId, $cycleId, $clientId, $customerData, array(), $couponId ? array($couponId) : array());

		if (!$response->hasErrors()) {
			foreach ($response->getData() as $data) {
				$_service = new BillingAdditionalService($data);
				if ($serviceId == $_service->getId()) {
					$service = $_service;
					break;
				}
			}
		}
		if (! $service) {
			throw new BillingObjectException('Service with id "' . $serviceId . '" not found');
		}
		return $service;
	}

	public function getByPlan($planId, $storeId, $cycleId, $couponIds = array(), $anonymously = false)
	{
		if (!$anonymously && ($customer = sfContext::getInstance()->getUser()->getAttribute('customer'))) {
			$customerId = $customer->getId();
		} else {
			$customerId = null;
		}

		$services = array();
		$response = $this->executeGetServices($storeId, $planId, null, $customerId, array(), $couponIds);
		if (!$response->hasErrors()) {
			foreach ($response->getData() as $data) {
				$services[] = new BillingAdditionalService($data);
			}
		}

		return $services;
	}

	public function getCountByPlan($planId, $storeId, $cycleId) {
		$count = 0;

		$response = $this->executeGetAddons($storeId, $planId, $cycleId, null);
		if (!$response->hasErrors()) {
			foreach ($response->getData() as $data) {
				$count++;
			}
		}

		return $count;
	}

	public static function getInstance()
	{
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('product'));
		}
		return self::$instance;
	}
}